#include <stdlib.h>
#include <string.h>
#include "defines.h"

double *alloc_double(int );
void sort_double(double *,int );

void pwm_profile(double **pwm,int pwmLen,char *dyad) {

   int i,j;
   for (i=0; i<pwmLen; i++) {
      if (pwm[i][0]==1 && pwm[i][1]==1 && pwm[i][2]==1 && pwm[i][3]==1) dyad[i]='n';
      else {
         for (j=0; j<4; j++) {
            if (pwm[i][j]==MAJOR) {
               switch (j) {
                  case 0:  dyad[i]='a'; break;
                  case 1:  dyad[i]='c'; break;
                  case 2:  dyad[i]='g'; break;
                  case 3:  dyad[i]='t'; break;
                  default: dyad[i]='n'; break;
               }
               break;
            }
         }
      }
   }
   dyad[pwmLen]='\0';
}

void consensus_pwm(double **pwm,int pwmLen,char *consensus) {

   register int i,j;
   int id[4],cn;
   double *col;

   col=alloc_double(4);

   for (i=0; i<pwmLen; i++) {
      for(j=0; j<4; j++) col[j]=pwm[i][j];
      sort_double(col,4);
      if (col[0]>0.5 && col[0]>2*col[1]) {
         for(j=0; j<4; j++) {
            if (col[0]==pwm[i][j]) { id[0]=j; break; }
         }
         switch(id[0]) {
            case 0: consensus[i]='a'; break;
            case 1: consensus[i]='c'; break;
            case 2: consensus[i]='g'; break;
            case 3: consensus[i]='t'; break;
            default: break;
         }
      }
      else if (col[0]+col[1]>=0.75 && col[1]<=0.5) {
         id[0]=-1;
         for(j=0; j<4; j++) {
            if (pwm[i][j]==col[0]) { id[0]=j; break; }
         }
         id[1]=-1;
         for(j=0; j<4; j++) {
            if (pwm[i][j]==col[1]) { id[1]=j; break; }
         }
         if (id[0]==id[1]) {
            cn=0;
            for(j=0; j<4; j++) {
               if (pwm[i][j]==col[0]) { id[cn]=j;  cn++; }
            }
         }
         if      ((id[0]==0 && id[1]==1)||(id[0]==1 && id[1]==0)) consensus[i]='m';
         else if ((id[0]==0 && id[1]==2)||(id[0]==2 && id[1]==0)) consensus[i]='r';
         else if ((id[0]==0 && id[1]==3)||(id[0]==3 && id[1]==0)) consensus[i]='w';
         else if ((id[0]==1 && id[1]==2)||(id[0]==2 && id[1]==1)) consensus[i]='s';
         else if ((id[0]==1 && id[1]==3)||(id[0]==3 && id[1]==1)) consensus[i]='y';
         else if ((id[0]==2 && id[1]==3)||(id[0]==3 && id[1]==2)) consensus[i]='k';
         else { }
      }
      else if (col[3]<=0.05) {
         for (j=0; j<4; j++) {
            if (pwm[i][j]==col[3]) { id[3]=j; break; }
         }
         switch(id[3]) {
            case 0: consensus[i]='b'; break; /* c, g, or t */
            case 1: consensus[i]='d'; break; /* a, g, or t */
            case 2: consensus[i]='h'; break; /* a, c, or t */
            case 3: consensus[i]='v'; break; /* a, c, or g */
            default: break;
         }
      }
      else consensus[i]='n';
   }
   consensus[pwmLen]='\0';
   if (col) { free(col); col=NULL; }
}

