
#include <stdlib.h>
#include <string.h>

void construct_pwm(double **pwm,double **score,double **rscore,char **seq,char **rseq,
   int *seqLen,int numseq,int motifLen,char *Iseq) {

   register int i,j,k;
   int tempid;
   //double sum;

   for (i=0; i<motifLen; i++) {
      for (j=0; j<4; j++) pwm[i][j]=0;
   }

   for(i=0; i<numseq; i++) {
      if (Iseq[i]=='0') continue;
      for(j=0; j<seqLen[i]-motifLen+1; j++){
         for(k=0; k<motifLen; k++) {
            switch (seq[i][j+k]) {
               case 'a': pwm[k][0] +=score[i][j]; break;
               case 'c': pwm[k][1] +=score[i][j]; break;
               case 'g': pwm[k][2] +=score[i][j]; break;
               case 't': pwm[k][3] +=score[i][j]; break;
               default: { pwm[k][0]+=(score[i][j]/4.0); pwm[k][1]+=(score[i][j]/4.0); pwm[k][2]+=(score[i][j]/4.0); pwm[k][3]+=(score[i][j]/4.0); break; }
            }
         }

         tempid=seqLen[i]-motifLen-j;
         for(k=0; k<motifLen; k++) {
            switch (rseq[i][tempid+k]) {
               case 'a': pwm[k][0] +=rscore[i][j]; break;
               case 'c': pwm[k][1] +=rscore[i][j]; break;
               case 'g': pwm[k][2] +=rscore[i][j]; break;
               case 't': pwm[k][3] +=rscore[i][j]; break;
               default: { pwm[k][0]+=(rscore[i][j]/4.0); pwm[k][1]+=(rscore[i][j]/4.0); pwm[k][2]+=(rscore[i][j]/4.0); pwm[k][3]+=(rscore[i][j]/4.0); break; }
            }
         }
      }
   }
   /*----------------------------------------------------
   for(i=0; i<motifLen; i++) {
      sum=0.0; for(j=0; j<4; j++) sum +=pwm[i][j];
      if(sum>0) { for(j=0; j<4; j++) pwm[i][j]/=sum;  }
      else      { for(j=0; j<4; j++) pwm[i][j] =0.25; }
   }
   ----------------------------------------------------*/
}

