
#include <stdlib.h>
#include "ga_dyads.h"

/* sort by increasing order */
void sort_fitness(Fitness *fitness,int size) {

   int (*compar)(const void *,const void *);

   compar=Compare_fitness;
   qsort((void *)fitness,(size_t)size,sizeof(Fitness),compar);
}

/* sort by increasing order */
int Compare_fitness(const void *s1, const void *s2) {

   if (((Fitness *)s1)->value < ((Fitness *)s2)->value) { return -1; }
   if (((Fitness *)s1)->value > ((Fitness *)s2)->value) { return  1; }
      return 0;
}

/* descending */
void sort_double(double *data,int size) {

   int (*compar)(const void *,const void *);

   compar = Compare_double;
   qsort((void *)data,(size_t)size,sizeof(double),compar);
}

int Compare_double(const void *s1, const void *s2) {

   if (*((double *)s1)< (*(double *)s2)) { return 1; }
   if (*((double *)s1)> (*(double *)s2)) { return -1; }
      return 0;
}

void sort_ptable(Mfunction *M1,int size) {

   int (*compar)(const void *,const void *);

   compar=Compare_M1;
   qsort((void *)M1,(size_t)size,sizeof(Mfunction),compar);
}

// sort in decending order
int Compare_M1(const void *s1, const void *s2) {

   if (((Mfunction *)s1)->score < ((Mfunction *)s2)->score) { return  1; }
   if (((Mfunction *)s1)->score > ((Mfunction *)s2)->score) { return -1; }
      return 0;
}

void sort_kmer_z(Ktuples *s2,int size) {

   int (*compar)(const void *,const void *);
   compar=Compare_z;
   qsort((void *)s2,(size_t)size,sizeof(Ktuples),compar);
}

int Compare_z(const void *s1,const void *s2) {

   if (((Ktuples *)s1)->z < ((Ktuples *)s2)->z) { return  1; }
   if (((Ktuples *)s1)->z > ((Ktuples *)s2)->z) { return -1; }
      return 0;
}

void sort_sites(Sites *site,int size) {

   int (*compar)(const void *,const void *);

   compar=Compare_site;
   qsort((void *)site,(size_t)size,sizeof(Sites),compar);
}

// sort in ascending order
int Compare_site(const void *s1, const void *s2) {

   if (((Sites *)s1)->pvalue < ((Sites *)s2)->pvalue) { return -1; }
   if (((Sites *)s1)->pvalue > ((Sites *)s2)->pvalue) { return  1; }
      return 0;
}

